Summary: Generic linux kernel
Name: kernel
Version: 2.0.30
%define version %{PACKAGE_VERSION}
%define pcmciaver 2.9.4
Release: 2
Copyright: GPL
Group: Base/Kernel
ExcludeArch: sparc
ExclusiveOS: Linux
Source: ftp://hyper.stanford.edu/pub/pcmcia/pcmcia-cs-%pcmciaver.tar.gz
Source1: ftp://ftp.funet.fi/pub/Linux/PEOPLE/Linus/v2.0/linux-%{version}.tar.gz
Source2: kernel-config.i386
Source3: pcmcia-cs-2.8.8-network.script
Source4: ftp://gear.torque.net/pub/bpcd.c
Source5: module-info
Source6: kernel-config.axp
Source7: http://cesdis.gsfc.nasa.gov/linux/drivers/3c59x.c
Source8: installkernel
Source9: http://cesdis.gsfc.nasa.gov/linux/drivers/eepro100.c
Patch: kernel-make.patch
Patch2: axp-diffs-2.0.30.gz
Patch3: linux-2.0.27-smallncr.patch
Patch4: axp-glibcdiffs-2.0.30.patch.gz
Patch5: 3c59x-nobm.patch
Patch6: linux-2.0.30-alphamachines.patch.gz
Patch7: linux-2.0.30-freemem.patch
BuildRoot: /tmp/kernel
Provides: module-info
Autoreqprov: no

%package source
Requires: kernel-headers = %{version}
Summary: Kernel source tree
Group: Base/Kernel

%package modules
Summary: Collection of kernel modules
Group: Base/Kernel
%ifarch i386
Requires: kernel = %{version}
%endif

%package -n pcmcia-cs
Requires: kernel = %{version}
Summary: Daemon and device drivers for using PCMCIA adapters
Group: Daemons
Version: %pcmciaver

%package headers
Summary: Header files for the Linux kernel.
Group: Base/Kernel

%description
This package contains the Linux kernel that is used to boot and run
your system. It contains few device drivers for specific hardware.
Most hardware is instead supported by modules loaded after booting.

%description source
This is the source code for the Linux kernel. It is required to build
most C programs as they depend on constants defined in here. You can
also build a custom kernel that is better tuned to your particular
hardware.

%description modules
This package includes the modules which provide the support for most
supported hardware devices.  The modules are loaded into the running
kernel after it is booted.

%description -n pcmcia-cs
Many laptop machines (and some others) support PCMCIA cards for expansion. 
Also known as "credit card adapters", PCMCIA cards are small cards for
everything from SCSI support to modems. They are hot swappable (they can
be exchanged without rebooting the system) and quite convienent. This package
contains support for numerous PCMCIA cards of all varieties and supplies a
daemon which allows them to be hot swapped.

%description headers
These are the C header files for the Linux kernel, which define structures
and constants that are needed when building most standard programs under
Linux, as well as to rebuild the kernel.

%changelog

* Tue Apr 22 1997 Erik Troan <ewt@redhat.com>

- Added linux-2.0.30-freemem.patch patch

* Tue Mar 25 1997 Erik Troan <ewt@redhat.com>

- Added /usr/include/linux, /usr/include/asm, and /usr/include/scsi symlinks
  to this package.
- Added default /sbin/installkernel (thanks to Tyson Sawyer)

%prep
if [ "X" != "${RPM_BUILD_ROOT}X" ]; then
    rm -rf $RPM_BUILD_ROOT
fi

%setup -c -q
mkdir -p $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr/src/
cd $RPM_BUILD_ROOT/usr/src
zcat $RPM_SOURCE_DIR/linux-%{version}.tar.gz | tar -xf-

find linux -name "*.orig" -print | xargs rm -f
mv linux linux-%{version}
ln -sfn linux-%{version} linux

cd linux-%{version}

cp -f $RPM_SOURCE_DIR/3c59x.c drivers/net
cd drivers/net
%patch5 -b .nobm -p0
cd ../..

%patch0 -p1
%patch3 -p1
%patch7 -p1

%ifarch alpha
%patch2 -p1 -b .axpdiffs
%patch4 -p1 -b .glibcdiffs
%patch6 -p1 -b .axpmachines
find include -name "*.axpdiffs" | xargs rm
find include -name "*.glibcdiffs" | xargs rm
find include -name "*.axpmachines" | xargs rm
%endif

%ifarch i386
cp $RPM_SOURCE_DIR/kernel-config.i386 arch/i386/defconfig
%endif
%ifarch alpha
cp $RPM_SOURCE_DIR/kernel-config.axp arch/alpha/defconfig
%endif

# We do this in %prep to let the pcmcia stuff get configured properly
make oldconfig
make dep

# now setup pcmcia stuff back in the build directory
cd $RPM_BUILD_DIR/kernel-%version
cd pcmcia-cs-%pcmciaver

make config <<EOF
$RPM_BUILD_ROOT/usr/src/linux
$RPM_BUILD_ROOT


$RPM_OPT_FLAGS
2
y
/etc/rc.d
EOF
cd ..
mkdir -p extra
cd extra
cp $RPM_SOURCE_DIR/bpcd.c .
cp $RPM_SOURCE_DIR/eepro100.c .
cd ..

%build
cd $RPM_BUILD_ROOT/usr/src/linux-%{version}
make include/linux/version.h

%ifarch i386
# we don't actually build a kernel package on the Alpha
rm -f /usr/include/linux 
ln -sf $RPM_BUILD_ROOT/usr/src/linux/include/linux /usr/include/linux
rm -f /usr/include/asm
ln -sf $RPM_BUILD_ROOT/usr/src/linux/include/asm /usr/include/asm
rm -f /usr/include/scsi
ln -sf $RPM_BUILD_ROOT/usr/src/linux/include/scsi /usr/include/scsi

make boot
make modules

rm -f /usr/include/linux 
ln -sf ../src/linux/include/linux /usr/include/linux
rm -f /usr/include/asm
ln -sf ../src/linux/include/asm /usr/include/asm
rm -f /usr/include/scsi
ln -sf ../src/linux/include/scsi /usr/include/scsi

# now for the extra modules CD driver
cd $RPM_BUILD_DIR/kernel-%{version}/extra
gcc -I$RPM_BUILD_ROOT/usr/src/linux/include -D__KERNEL__ -DMODULE -DMODVERSIONS -include $RPM_BUILD_SOOR/usr/src/linux/include/linux/modversions.h -O2 -c bpcd.c
gcc -I$RPM_BUILD_ROOT/usr/src/linux/include -D__KERNEL__ -DMODULE -DMODVERSIONS -include $RPM_BUILD_SOOR/usr/src/linux/include/linux/modversions.h -O2 -c eepro100.c
%endif

cd $RPM_BUILD_DIR/kernel-%{version}/pcmcia-cs-%pcmciaver
make all

%install

mkdir -p $RPM_BUILD_ROOT/usr/include
ln -s ../src/linux/include/asm $RPM_BUILD_ROOT/usr/include/asm
ln -s ../src/linux/include/linux $RPM_BUILD_ROOT/usr/include/linux
ln -s ../src/linux/include/scsi $RPM_BUILD_ROOT/usr/include/scsi

%ifarch i386
mkdir -p $RPM_BUILD_ROOT/sbin
install -m 755  $RPM_SOURCE_DIR/installkernel $RPM_BUILD_ROOT/sbin/installkernel
%endif

cd $RPM_BUILD_ROOT/usr/src/linux-%{version}
mkdir -p $RPM_BUILD_ROOT/boot
cp $RPM_SOURCE_DIR/module-info $RPM_BUILD_ROOT/boot/module-info-%{version}

%ifarch i386
cp System.map $RPM_BUILD_ROOT/boot/System.map-%{version}
cp arch/i386/boot/zImage $RPM_BUILD_ROOT/boot/vmlinuz-%{version}
ln -sf vmlinuz-%{version} $RPM_BUILD_ROOT/boot/vmlinuz
%endif

mkdir -p $RPM_BUILD_ROOT/lib/modules

%ifarch i386
make PREFIX=$RPM_BUILD_ROOT modules_install
cp $RPM_BUILD_DIR/kernel-%{version}/extra/bpcd.o $RPM_BUILD_ROOT/lib/modules/%{version}/cdrom
cp $RPM_BUILD_DIR/kernel-%{version}/extra/eepro100.o $RPM_BUILD_ROOT/lib/modules/%{version}/net
%endif

cd $RPM_BUILD_ROOT/usr/src/linux-%{version}

# keep kernel-source archive clean
make mrproper
make oldconfig
make symlinks
make include/linux/version.h

# this generates modversions info which we want to include and we may as
# well include the depends stuff as well
make depend

# this is dumb :-)
make -C scripts/lxdialog all

%ifarch i386 alpha
mkdir -p $RPM_BUILD_ROOT/etc/pcmcia
mkdir -p $RPM_BUILD_ROOT/etc/sysconfig

cd $RPM_BUILD_DIR/kernel-%{version}/pcmcia-cs-%pcmciaver
make install

# Install our own network up/down script
install -m755 $RPM_SOURCE_DIR/pcmcia-cs-2.8.8-network.script \
        $RPM_BUILD_ROOT/etc/pcmcia/network

# We need our own default /etc/sysconfig/pcmcia
echo PCMCIA=no > $RPM_BUILD_ROOT/etc/sysconfig/pcmcia
echo PCIC= >> $RPM_BUILD_ROOT/etc/sysconfig/pcmcia 
echo PCIC_OPTS= >> $RPM_BUILD_ROOT/etc/sysconfig/pcmcia
echo CORE_OPTS= >> $RPM_BUILD_ROOT/etc/sysconfig/pcmcia

mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc0.d
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc2.d
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc3.d
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc5.d
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc6.d
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d

mv $RPM_BUILD_ROOT/etc/rc.d/rc.pcmcia $RPM_BUILD_ROOT/etc/rc.d/init.d/pcmcia

# We use different default sequence numbers
ln -sf ../init.d/pcmcia $RPM_BUILD_ROOT/etc/rc.d/rc0.d/K52pcmcia
ln -sf ../init.d/pcmcia $RPM_BUILD_ROOT/etc/rc.d/rc2.d/S45pcmcia
ln -sf ../init.d/pcmcia $RPM_BUILD_ROOT/etc/rc.d/rc3.d/S45pcmcia
ln -sf ../init.d/pcmcia $RPM_BUILD_ROOT/etc/rc.d/rc5.d/S45pcmcia
ln -sf ../init.d/pcmcia $RPM_BUILD_ROOT/etc/rc.d/rc6.d/K52pcmcia

# Finally strip some binaries
cd $RPM_BUILD_ROOT/sbin
strip cardmgr cardctl probe scsi_info ftl_format ftl_check
%endif

%clean
if [ "X" != "${RPM_BUILD_ROOT}X" ]; then
    rm -rf $RPM_BUILD_ROOT
fi

%post
cd /boot
ln -sf vmlinuz-%{version} vmlinuz
ln -sf System.map-%{version} System.map
ln -sf module-info-%{version} module-info

if [ -x /sbin/lilo -a -f /etc/lilo.conf ]; then
	/sbin/lilo > /dev/null
fi

%post headers
cd /usr/src
ln -snf linux-%{version} linux

%post source
cd /usr/src
ln -snf linux-%{version} linux

%postun headers

if [ -L /usr/src/linux ]; then 
    if [ `ls -l /usr/src/linux | awk '{ print $11 }'` = "linux-%{version}" ]; then
	rm -f /usr/src/linux
    fi
fi

%preun modules
if [ `uname -r` = "%{version}" ]; then 
	echo "You cannot remove the kernel-modules package for the currently "
	echo "running kernel".
	exit 1
fi

%ifarch i386
%files
/boot/vmlinuz-*
/boot/System.map-%{version}
/boot/module-info-%{version}
/sbin/installkernel
%endif

%files source
%dir /usr/src/linux-%{version}
/usr/src/linux-%{version}/COPYING
/usr/src/linux-%{version}/CREDITS
/usr/src/linux-%{version}/Documentation
/usr/src/linux-%{version}/MAINTAINERS
/usr/src/linux-%{version}/Makefile
/usr/src/linux-%{version}/Makefile.orig
/usr/src/linux-%{version}/README
/usr/src/linux-%{version}/Rules.make
/usr/src/linux-%{version}/arch
/usr/src/linux-%{version}/drivers
/usr/src/linux-%{version}/fs
/usr/src/linux-%{version}/init
/usr/src/linux-%{version}/ipc
/usr/src/linux-%{version}/kernel
/usr/src/linux-%{version}/lib
/usr/src/linux-%{version}/mm
/usr/src/linux-%{version}/modules
/usr/src/linux-%{version}/net
/usr/src/linux-%{version}/scripts

%ifarch i386
%files modules
%dir /lib/modules
%dir /lib/modules/%{version}
/lib/modules/%{version}/scsi
/lib/modules/%{version}/net
/lib/modules/%{version}/block
/lib/modules/%{version}/cdrom
/lib/modules/%{version}/fs
/lib/modules/%{version}/misc
/lib/modules/%{version}/ipv4
%endif

%ifarch i386 alpha
%files -n pcmcia-cs
%doc pcmcia-cs-%pcmciaver/doc/PCMCIA-HOWTO 
%doc pcmcia-cs-%pcmciaver/SUPPORTED.CARDS 
%doc pcmcia-cs-%pcmciaver/CHANGES 
%doc pcmcia-cs-%pcmciaver/COPYING 
%doc pcmcia-cs-%pcmciaver/README
/lib/modules/%{version}/pcmcia

/sbin/cardmgr
/sbin/cardctl
/sbin/probe
/sbin/scsi_info

/sbin/ftl_format
/sbin/ftl_check

/usr/man/man1/cardinfo.1

/usr/man/man8/cardmgr.8
/usr/man/man8/cardctl.8
/usr/man/man8/ftl_format.8
/usr/man/man8/ftl_check.8
/usr/man/man8/scsi_info.8

/usr/man/man5/pcmcia.5
/usr/man/man5/stab.5

/usr/man/man4/pcmcia_core.4
/usr/man/man4/tcic.4
/usr/man/man4/i82365.4
/usr/man/man4/tc589_cs.4
/usr/man/man4/pcnet_cs.4
/usr/man/man4/serial_cs.4
/usr/man/man4/pcmem_cs.4
/usr/man/man4/ftl_cs.4
/usr/man/man4/memory_cs.4

/etc/rc.d/rc0.d/K52pcmcia
/etc/rc.d/rc2.d/S45pcmcia
/etc/rc.d/rc3.d/S45pcmcia
/etc/rc.d/rc5.d/S45pcmcia
/etc/rc.d/rc6.d/K52pcmcia

%config /etc/rc.d/init.d/pcmcia
%config /etc/sysconfig/pcmcia
%dir /etc/pcmcia
/etc/pcmcia/config
/etc/pcmcia/fixed
/etc/pcmcia/ftl
/etc/pcmcia/memory
/etc/pcmcia/network
/etc/pcmcia/pcmem
/etc/pcmcia/scsi
/etc/pcmcia/serial

%config /etc/pcmcia/config.opts
%config /etc/pcmcia/fixed.opts
%config /etc/pcmcia/ftl.opts
%config /etc/pcmcia/memory.opts
%config /etc/pcmcia/pcmem.opts
%config /etc/pcmcia/scsi.opts
%config /etc/pcmcia/serial.opts
%endif

%files headers
/usr/src/linux-%{version}/include/asm
/usr/src/linux-%{version}/include/asm-generic
/usr/src/linux-%{version}/include/linux
/usr/src/linux-%{version}/include/net
/usr/src/linux-%{version}/include/scsi
/usr/include/asm
/usr/include/linux
/usr/include/scsi

%ifarch alpha
/usr/src/linux-%{version}/include/asm-alpha
%endif

%ifarch i386
/usr/src/linux-%{version}/include/asm-i386
%endif

%ifarch sparc
/usr/src/linux-%{version}/include/asm-sparc
%endif
